// SPDX-License-Identifier: GPL-2.0-or-later
/*
 * Copyright (C) Telechips Inc.
 */

#ifndef TCC803X_REG_CONFIG_H
#define TCC803X_REG_CONFIG_H

/* Part 2. SMU & CKC */

#define TCC_CKC_BASE		0x14000000U
#define TCC_VIC_BASE		0x14100000U
#define TCC_GPIO_BASE		0x14200000U
#define TCC_PMGPIO_BASE		0x1B937000U
#define TCC_TIMER_BASE		0x14300000U
#define TCC_PMU_BASE		0x14400000U

#define TCC_ECID_UID_PD0	(TCC_PMU_BASE + 0x100U)
#define TCC_ECID_UID_PD1	(TCC_PMU_BASE + 0x104U)

/* Part 3. Graphic */
#define TCC_GPU3D_BASE		0x10000000U
#define TCC_GPU2D_BASE		0x1A000000U

/* Part 4. Memory */
#define TCC_MBUSCFG_BASE	0x13500000U

/* Part 5. IO */
#define TCC_UART0_BASE		0x16600000U
#define TCC_UART1_BASE		0x16610000U
#define TCC_UART2_BASE		0x16620000U
#define TCC_UART3_BASE		0x16630000U
#define TCC_UART4_BASE		0x16640000U
#define TCC_UART5_BASE		0x16650000U
#define TCC_UART6_BASE		0x16660000U
#define TCC_UART7_BASE		0x16670000U
#define TCC_UART8_BASE		0x16690000U
#define TCC_UART_CFG		0x16689000U
#define TCC_IOBUSCFG_BASE	0x16051000U
#define TCC_IOBUSCFG1_BASE	0x16494400U

#define TCC_I2C0_BASE		0x16300000U
#define TCC_I2C1_BASE		0x16310000U
#define TCC_I2C2_BASE		0x16320000U
#define TCC_I2C3_BASE		0x16330000U
#define TCC_I2C_PCFG_BASE	0x163c0000U
#define TCC_I2C_ISTS		0x10U
#define TCC_I2C_PCFG(x)         (TCC_I2C_PCFG_BASE + (0x4U * x))
#define TCC_I2C_HDMI_PORT       3U
#define TCC_I2C_HDMI_MASK       0xFU
#define TCC_I2C_HDMI_MAPPING    0x1DU

#define TCC_GPSB0_BASE		0x16900000U
#define TCC_GPSB1_BASE		0x16910000U
#define TCC_GPSB2_BASE		0x16920000U
#define TCC_GPSB3_BASE		0x16930000U
#define TCC_GPSB4_BASE		0x16940000U
#define TCC_GPSB5_BASE		0x16950000U
#define TCC_GPSB6_BASE		0x16990000U
#define TCC_GPSB_PCFG_BASE	0x16960000U
#define TCC_GPSB_PCFG(x)	(TCC_GPSB_PCFG_BASE + (0x4U * x))
#define TCC_GPSB_CIRQST		0x1696000CU

/* Part 6. High Speed H/O */
#define PCIECFG_BASE            0x118A0000U
#define USB20OTG_BASE		0x11980000U
#define TCC_HSIOBUSCFG_BASE	0x11DA0000U
#define USBPHYCFG_EHCI_MUX_BASE	(TCC_HSIOBUSCFG_BASE + 0xE0U)
#define USBPHYCFG_BASE		(TCC_HSIOBUSCFG_BASE + 0x100U)
#define USB20OTG_MUX_SEL	(TCC_HSIOBUSCFG_BASE + 0x128U)

/* Part 7. Display */
#define TCC_VIOC_BASE		0x12000000UL
#define TCC_DBUSCFG_BASE	0x12380000UL
#define TCC_VIOC_OUTCONFIG_BASE (TCC_VIOC_BASE + 0x100200UL)
#define TCC_HDMI_LINK_BASE      0x12400000UL
#define TCC_HDMI_PHY_BASE       0x12480000UL

/* Part 8. Video */
#define TCC_VBUSCFG_BASE	0x15100000U

/* Part 10. CPU */
#define TCC_CPUBUSCFG_BASE	0x17000000U

#define TCC_CA72MP_BUS_BASE	0x17100000U
#define TCC_CA53MP_BUS_BASE	0x17200000U

#endif /* TCC803X_REG_CONFIG_H */
